package dev.shadowsoffire.apotheosis.adventure.gen;

import java.util.function.BiFunction;
import com.mojang.datafixers.kinds.Applicative;
import java.util.function.Function;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraftforge.common.world.ModifiableBiomeInfo;
import com.mojang.serialization.Codec;
import net.minecraft.world.level.levelgen.placement.PlacedFeature;
import net.minecraft.core.Holder;
import net.minecraft.world.level.biome.Biome;
import net.minecraft.core.HolderSet;
import net.minecraftforge.common.world.BiomeModifier;

record BlacklistModifier(HolderSet<Biome> blacklistedBiomes, Holder<PlacedFeature> feature) implements BiomeModifier {
    public static final Codec<BlacklistModifier> CODEC;
    
    public void modify(final Holder<Biome> biome, final BiomeModifier.Phase phase, final ModifiableBiomeInfo.BiomeInfo.Builder builder) {
        if (phase == BiomeModifier.Phase.ADD && !this.blacklistedBiomes.m_203333_((Holder)biome)) {
            builder.getGenerationSettings().m_255419_(GenerationStep.Decoration.UNDERGROUND_STRUCTURES, (Holder)this.feature);
        }
    }
    
    public Codec<? extends BiomeModifier> codec() {
        return (Codec<? extends BiomeModifier>)BlacklistModifier.CODEC;
    }
    
    static {
        CODEC = RecordCodecBuilder.create(builder -> builder.group((App)Biome.f_47432_.fieldOf("blacklisted_biomes").forGetter((Function)BlacklistModifier::blacklistedBiomes), (App)PlacedFeature.f_191773_.fieldOf("feature").forGetter((Function)BlacklistModifier::feature)).apply((Applicative)builder, (BiFunction)BlacklistModifier::new));
    }
}
